# Copyright (c) 2000-2005, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define _with_gcj_support 1

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

# If you don't want to run the unit tests
# give rpmbuild option '--without tests'

%define with_tests %{!?_without_tests:1}%{?_without_tests:0}
%define without_tests %{?_without_tests:1}%{!?_without_tests:0}


%define section	free

Name:		jgroups
Version:	2.2.9.2
Release:	3jpp.2
Epoch:		0
Summary:	Toolkit for reliable multicast communication.
License:	LGPL
URL:		http://www.jgroups.org/
Group:		Development/LIbraries/Java
Source0:	JGroups-2.2.9.2.src-RHCLEAN.tar.gz
Patch0:		jgroups-2.2.9-build_xml.patch
Requires:	bsh
Requires:	concurrent
Requires:	jakarta-commons-logging
Requires:	jaxp_parser_impl
Requires:	jms
Requires:	log4j
Requires:	mx4j
Requires:	xalan-j2
Requires:	bouncycastle
BuildRequires:	ant >= 0:1.6
BuildRequires:	bsh
BuildRequires:	concurrent
BuildRequires:	jakarta-commons-logging
BuildRequires:	jaxp_parser_impl
BuildRequires:	jms
BuildRequires:	jpackage-utils >= 0:1.6
BuildRequires:	junit
BuildRequires:	ant-junit
BuildRequires:	log4j
BuildRequires:	mx4j
BuildRequires:	xalan-j2
BuildRequires:	bouncycastle
%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%if %{gcj_support}
BuildRequires:		java-gcj-compat-devel
Requires(post):		java-gcj-compat
Requires(postun):	java-gcj-compat
%endif

%description
JGroups is a toolkit for reliable multicast communication. (Note that
this doesn't necessarily mean IP Multicast, JGroups can also use
transports such as TCP). It can be used to create groups of processes
whose members can send messages to each other. The main features include

    * Group creation and deletion. Group members can be spread across
      LANs or WANs
    * Joining and leaving of groups
    * Membership detection and notification about joined/left/crashed members
    * Detection and removal of crashed members
    * Sending and receiving of member-to-group messages (point-to-multipoint)
    * Sending and receiving of member-to-member messages (point-to-point)

%package	javadoc
Summary:	Javadoc for %{name}
Group:		Development/Documentation
Requires(post):   /bin/ln
Requires(post):   /bin/rm
Requires(postun): /bin/rm

%description	javadoc
%{summary}.

%package	manual
Summary:	Documents for %{name}
Group:		Development/Documentation

%description	manual
%{summary}.

%prep
%setup -q -n JGroups-2.2.9.2.src
for j in $(find . -name "*.jar"); do
    mv $j $j.no
done

# this test requires bouncycastle
#rm tests/junit/org/jgroups/protocols/ENCRYPTAsymmetricTest.java

%patch0 -b .sav

%build
export OPT_JAR_LIST="ant-launcher ant/ant-junit junit"
pushd lib
ln -sf $(build-classpath bsh) .
ln -sf $(build-classpath commons-logging) .
ln -sf $(build-classpath concurrent) .
ln -sf $(build-classpath jms) .
ln -sf $(build-classpath junit) .
ln -sf $(build-classpath log4j) .
ln -sf $(build-classpath mx4j/mx4j-jmx) .
popd
%if %{without_tests}
ant jar javadoc jboss-service jgroups-service
%else
export ANT_OPTS="-Djava.net.preferIPv4Stack=true"
# Added gcj-endorsed/bc-prov to build the encrypt test
export CLASSPATH=$CLASSPATH:`build-classpath xalan-j2 xalan-j2-serializer gcj-endorsed/bc-prov`
ant jar javadoc jboss-service jgroups-service unittests testreport
%endif

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 dist/%{name}-all.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -m 644 dist/%{name}-core.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}-core-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do \
ln -sf ${jar} ${jar/-%{version}/}; done)

# javadoc
install -p -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr dist/javadoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
(cd $RPM_BUILD_ROOT%{_javadocdir} && ln -sf %{name}-%{version} %{name})

# services
install -p -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
install -m 644 dist/%{name}*.sar \
	$RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}

# docs
install -p -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr doc/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ $1 -eq 0 ]; then
  rm -f %{_javadocdir}/%{name}
fi

%post
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%{_javadir}/*
%{_datadir}/%{name}-%{version}

%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/jgroups-2.2.9.2.jar.*
#This is generated by spec-convert-gcj-* but this is a subset...
#%attr(-,root,root) %{_libdir}/gcj/%{name}/jgroups-core-2.2.9.2.jar.*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%dir %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}-%{version}/*
%ghost %dir %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}

%changelog
* Fri Aug 14 2006 Vivek Lakshmanan <vivekl@redhat.com> - 0:2.2.9.2-3jpp.2
- Keep ENCRYPTAsymmetricTest since BC now available.

* Fri Aug 11 2006 Vivek Lakshmanan <vivekl@redhat.com> - 0:2.2.9.2-3jpp.1
- Resync with latest from JPP.
- Re-enable bouncycastle dependencies.

* Mon Jul 24 2006 Vivek Lakshmanan <vivekl@redhat.com> - 0:2.2.9.2-2jpp_2fc
- Rebuild.

* Sun Jul 23 2006 Vivek Lakshmanan <vivekl@redhat.com> - 0:2.2.9.2-2jpp_1fc
- Merge with latest version from JPP.
- Remove jars from the source tarball.
- Add ant-junit as a build requires.
- Remove tests/junit/org/jgroups/protocols/ENCRYPTAsymmetricTest.java
  temporarily since it needs BouncyCastle.

* Sat Jul 22 2006 Jakub Jelinek <jakub@redhat.com> - 0:2.2.6-1jpp_7fc
- Rebuilt

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com> - 0:2.2.6-1jpp_6fc
- rebuild

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com> - 0:2.2.6-1jpp_5fc
- rebuild

* Mon Mar  6 2006 Jeremy Katz <katzj@redhat.com> - 0:2.2.6-1jpp_4fc
- stop scriptlet spew

* Wed Dec 21 2005 Jesse Keating <jkeating@redhat.com> 0:2.2.6-1jpp_3fc
- rebuilt again

* Fri Dec 09 2005 Jesse Keating <jkeating@redhat.com> 0:2.2.6-1jpp_2fc
- rebuilt

* Thu Jun 16 2005 Gary Benson <gbenson@redhat.com> 0:2.2.6-1jpp_1fc
- Build into Fedora.

* Thu Jun  9 2005 Gary Benson <gbenson@redhat.com>
- Remove jarfiles from the tarball.

* Thu Dec 02 2004 Fernando Nasser <fnasser@redhat.com> 0:2.2.6-1jpp_1rh
- First Red Hat release

* Thu Sep 16 2004 Ralph Apel <r.apel at r-apel.de> 0:2.2.6-1jpp
- upgrade to 2.2.6

* Sun Aug 23 2004 Randy Watler <rwatler at finali.com> - 0:2.2-3jpp
- Rebuild with ant-1.6.2

* Tue Jun 01 2004 Randy Watler <rwatler at finali.com> - 0:2.2-2jpp
- Upgrade to Ant 1.6.X

* Sun Jan 25 2004 David Walluck <david@anti-microsoft.org> 0:2.2-1jpp
- update source
